% Stato: x=[y,yp]

A=[0 1;
   -1 -2];
B=[0;1];
C=[1 0];
D=0;

sys=ss(A,B,C,D);

Ts=1;     % Tempo di campionamento
tau=4*Ts; % Ritardo

% Risposta al gradino sistema con ritardo:
sysdelay=sys;
sysdelay.inputdelay=tau;
step(sysdelay);

% Risposta al gradino sistema con ritardo discretizzato:
sysdelayz=c2d(sysdelay,Ts);
figure;
step(sysdelay,sysdelayz);

sysd=c2d(sys,Ts);
[Az,Bz]=ssdata(sysd);

% Verifica: confronta risposte al gradino
%step(sysd,sys)

% Controllore
polidiscreto=[.4+.4*j .4-.4*j];
K=-acker(Az,Bz,polidiscreto); 


% Compensazione ritardo: x(t+4)=A^4 x(t)+Bu(t-3)+ABu(t-2)+A^2Bu(t-1)

y0=0; % Condizione iniziale sull'uscita
yp0=0; % Condizione iniziale sulla derivata dell'uscita

v=1; % Segnale di riferimento
Kv=1/dcgain(ss((Az+Bz*K),Bz,C,D,Ts));

open('delay_sim')
T=20;
sim('delay_sim',T)

% Cambia sfondo agli Scope
scopes = find_system(bdroot,'BlockType','Scope');
for i = 1:length(scopes)
   h = get_param(scopes{i,:},'Figure');
   %set(h,'Color',[.8 .8 .8]);
    h1 = findobj(h,'Type','axes');
    set(h1,'Color',[.8 .8 .8]);
    h1 = findobj(h,'Type','line');
    set(h1,'Color',[0 0 1],'LineWidth',2.0);
 end

bigA=[Az   Bz zeros(2,3);
      0 0   0 1 0 0;
      0 0   0 0 1 0;
      0 0   0 0 0 1;
      0 0   0 0 0 0];
bigB=[0;0;0;0;0;1];
bigC=[1 0 0 0 0 0];
bigD=0;

bigK=K*[Az^4 Az^3*Bz Az^2*Bz Az*Bz Bz];
eig(bigA+bigB*bigK)